#include "boot_sectors.h"
#include "stm32f4xx_flash.h"

#include <stdint.h>


uint8_t * boot_sector_flag_address()
{
    const uint32_t * start  = (const uint32_t *)flashSectors[FLAGS_SECTOR].address;
    const uint32_t * end    = (const uint32_t *)flashSectors[FLAGS_SECTOR+1].address;
    const uint32_t * memory = start;

    while (memory < end && *memory != 0xffffffff)
    {
        memory++;
    }

    if (memory != start) memory--;

    uint8_t * bytes = (uint8_t *)memory;

    while (bytes < (uint8_t *)end && *bytes != 0xff)
    {
        bytes++;
    }

    if (bytes != (uint8_t *)start) bytes--;

    return bytes;
}


size_t find_boot_sector()
{
    const uint8_t * bytes = boot_sector_flag_address();

    size_t sector = *bytes;

    if (sector >= STM32F4xx_FLASH_NUM_SECTORS)
    {
        sector = PROG_A_SECTOR;
    }

    return sector;
}

