#ifndef BOOT_SECTORS_H_
#define BOOT_SECTORS_H_

#include <stddef.h>
#include <stdint.h>


#define BOOTLOADER_SECTOR   (0)
#define FLAGS_SECTOR        (1)

#define PROG_A_SECTOR       (5)
#define PROG_B_SECTOR       (6)

#define FILE_SECTOR         (11)


typedef struct
{
    uint32_t size;
    uint32_t crc;
} FlashHeader;


uint8_t * boot_sector_flag_address();
size_t find_boot_sector();


#endif // BOOT_SECTORS_H_
