#ifndef FLASH_H_
#define FLASH_H_

#include <stdint.h>
#include <stddef.h>

#define STM32F4xx_FLASH_NUM_SECTORS     (12)

#define STM32F4xx_FLASH_SECTOR_0_SIZE   ( 16 * 1024)
#define STM32F4xx_FLASH_SECTOR_1_SIZE   ( 16 * 1024)
#define STM32F4xx_FLASH_SECTOR_2_SIZE   ( 16 * 1024)
#define STM32F4xx_FLASH_SECTOR_3_SIZE   ( 16 * 1024)
#define STM32F4xx_FLASH_SECTOR_4_SIZE   ( 64 * 1024)
#define STM32F4xx_FLASH_SECTOR_5_SIZE   (128 * 1024)
#define STM32F4xx_FLASH_SECTOR_6_SIZE   (128 * 1024)
#define STM32F4xx_FLASH_SECTOR_7_SIZE   (128 * 1024)
#define STM32F4xx_FLASH_SECTOR_8_SIZE   (128 * 1024)
#define STM32F4xx_FLASH_SECTOR_9_SIZE   (128 * 1024)
#define STM32F4xx_FLASH_SECTOR_10_SIZE  (128 * 1024)
#define STM32F4xx_FLASH_SECTOR_11_SIZE  (128 * 1024)


typedef struct
{
    size_t    number;
    uint8_t * address;
    size_t    size;
} FlashSector;


extern const FlashSector flashSectors[STM32F4xx_FLASH_NUM_SECTORS];


#endif // FLASH_H_
