#include "unique_id.h"

#include <stddef.h>
#include <stdbool.h>

// For reference.
//#define DEVICE_ID1      (0x1FFF7A10)
//#define DEVICE_ID2      (0x1FFF7A14)
//#define DEVICE_ID3      (0x1FFF7A18)


/// Obfuscate the address we're reading from
uint32_t get_address()
{
    uint16_t x[4];
    for (size_t i = 0; i < 4; ++i)
    {
        x[i] = i * 0x1000;
    }

    uint32_t ptr = *(uint32_t *)(x + 1);
    ((uint16_t *)&ptr)[1] -= 1;
    ptr += 0x6a10;

    return ptr;
}

uint32_t unique_id_1()
{
    return ((uint32_t *)get_address())[0];
}

uint32_t unique_id_2()
{
    return ((uint32_t *)get_address())[1];
}

uint32_t unique_id_3()
{
    return ((uint32_t *)get_address())[2];
}


uint32_t munged_id()
{
    // Treat the UID as a string of bytes.
    const uint8_t * uid = (const uint8_t *)get_address();

    //                            111111
    //                  0123456789012345
    const char * key = "ChamSys Limited";

    uint32_t result = 0;
    uint8_t * ptr = (uint8_t *)&result;

    // Generate 12 indices into the UID, using the "innocent looking" string
    // as a starting point, and ensuring we generate all 12 indices once only.
    size_t indices[12];

    for (size_t i = 0; i < 12; i++)
    {
        size_t index = (key[i] * 197 + i) % 12;

        bool unique = false;
        while (!unique)
        {
            unique = true;
            for (size_t j = 0; j < i; ++j)
            {
                if (indices[j] == index)
                {
                    index += 907;
                    index = index % 12;
                    unique = false;
                    break;
                }
            }
        }

        indices[i] = index;

        // XOR the byte of the UID into the result
        ptr[i%4] ^= uid[index];
    }

    return result;
}
